#!/usr/bin/python
import os, socket, subprocess, sys
# Nagios Status: o.k.
ok = [ "EmailTest" ]
# Nagios Status: Warning
warning = [ "FailedOpenDevice" ]
# Nagios Status: Critical
critical = [
    "Usage",
    "Health",
    "SelfTest",
    "ErrorCount",
    "FailedHealthCheck",
    "FailedReadSmartData",
    "FailedReadSmartErrorLog",
    "FailedReadSmartSelfTestLog",
    "CurrentPendingSector",
    "OfflineUncorrectableSector",
    "Temperature",
    ]
# diese Nachrichten nicht ans Nagios weiterleiten
ignore = []
send_nsca_cmd = "/usr/local/sbin/send_nsca -H nagios.example.com -c /etc/send_nsca.cfg"
def send_nsca(device, status, output):
    fqdn = socket.getfqdn()
    pipe = subprocess.Popen(send_nsca_cmd, shell=True, stdin=subprocess.PIPE).stdin
    print >>pipe, "%(fqdn)s\tSmart Status %(device)s\t%(status)s\t%(output)s" % locals()
    pipe.close()
def main(argv):
    device = os.getenv("SMARTD_DEVICESTRING")
    failure = os.getenv("SMARTD_FAILTYPE")
    msg = os.getenv("SMARTD_MESSAGE")
    if failure in critical:
        status = 2
    elif failure in warning:
        status = 1
    elif failure in ok:
        msg = "disk ok"
        status = 0
    elif failure in ignore:
        return 0
    else:
        msg = "Unbekannte Nachricht:" + failure
        status = 1
    send_nsca(device, status, msg)
if __name__ == '__main__':
    sys.exit(main(sys.argv))
